/*
 * Testtreiberklasse, welche das Bankensystem testet.
 * Es werden neue Bankkonten angelegt und Geld deponiert,
 * abgehoben und transferiert.
 */
public class Main {
	
	/*
	 * Main Methode fuehrt bestimmte Testfaelle aus.
	 */
	public static void main(String[] args) {
		Bank b = new Bank();
		int c1, s2, s3, c4, c5;
		// Verschiedene Konten erzeugen
		c1 = b.getNewCurrentAccount();
		s2 = b.getNewSavingsAccount();
		s3 = b.getNewSavingsAccount();
		c4 = b.getNewCurrentAccount();
		c5 = b.getNewCurrentAccount();
		
		// Geld auf den Konten einzahlen
		b.depositMoney(c1, 200f);
		b.depositMoney(s2, 300f);
		b.depositMoney(s3, 400f);
		b.withdrawMoney(c4, 500f);
		b.depositMoney(c5, 1200);
		
		// Zeigt den insgesamt einbezahlten Betrag auf der Bank.
		// Muss 1600 GE sein.
		System.out.println("Current Bank balance: " + b.getBankBalance());
				
		// transferiert von Konto c5 nach Konto c4 600 Geldeinheiten
		// Danach: 
		// c5 --> 600
		// c4 --> 100
		b.transferAmount(c5, c4, 600);
				
		// Zeigt alle Konten und deren Saldi an.
		// Muss zeigen:
		// 
		b.summarizeBank();
	
		// Sollte zeigen:
		//Account 5 has balance of 600.0
		//Account 4 has balance of 100.0
		//Account 3 has balance of 400.0
		//Account 2 has balance of 300.0
		//Account 1 has balance of 200.0
		//Total amount deposited in bank:1600.0
		
		
		// Geld abheben von Konto c5 (500 GE)
		b.withdrawMoney(c5, 700);
		
		// Nun sind -100 GE auf Konto c5
		
		try {
			// Geld abheben von s2 funktioniert --> danach 75 GE auf Konto
			b.withdrawMoney(s2, 225f);
			// Geld abheben von s2 --> danach 0 GE auf dem Konto
			b.withdrawMoney(s2, 75);
			// Geld abheben von s3 --> geht nicht, da Sparkonto und nur 440 GE
			// auf Konto --> Exception
			b.withdrawMoney(s3, 475f); // gibt eine Exception
		} catch (Exception ex) {
			// Exception info
			ex.printStackTrace();
		}

		//java.lang.RuntimeException: Balance of 400.0 to low for withdrawing amount of 475.0
		//at SavingsAccount.withdraw(SavingsAccount.java:46)
		//at Bank.withdrawMoney(Bank.java:140)
		//at Main.main(Main.java:65)
		
		// Aktueller Bankinhalt anzeigen.
		b.summarizeBank();
		
		//Sollte zeigen:
		//Account 5 has balance of -100.0
		//Account 4 has balance of 100.0
		//Account 3 has balance of 400.0
		//Account 2 has balance of 0.0
		//Account 1 has balance of 200.0
		//Total amount deposited in bank:600.0
		b.removeAccount(c5);
		
		System.out.println("Account " + c5 + " existing: " + b.accountExists(c5));
		
		//Account 5 existing: false
		//Account 4 has balance of 100.0
		//Account 3 has balance of 400.0
		//Account 2 has balance of 0.0
		//Account 1 has balance of 200.0
		//Total amount deposited in bank:700.0
		b.summarizeBank();
		
		int c6 = b.getNewCurrentAccount();
		
		b.withdrawMoney(c6, 100);
		
		b.summarizeBank();
		//Account 6 has balance of -100.0
		//Account 4 has balance of 100.0
		//Account 3 has balance of 400.0
		//Account 2 has balance of 0.0
		//Account 1 has balance of 200.0
		//Total amount deposited in bank:600.0
		
		// Zinsen berechnen fr alle Bankkonten
		b.accumulateInterests();
		
		b.summarizeBank();
		//Account 6 has balance of -109.0
		//Account 4 has balance of 100.025
		//Account 3 has balance of 405.0
		//Account 2 has balance of 0.0
		//Account 1 has balance of 200.05
		//Total amount deposited in bank:596.075
		}
}